//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Unit2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "RichView"
#pragma link "RVEdit"
#pragma link "RVScroll"
#pragma link "RVStyle"
#pragma link "RxGIF"
#pragma link "PtblRV"
#pragma link "RVReport"
#pragma link "RVTable"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TForm1::MakeHeader(TRVReportHelper*rvh, int PageNo, int PageCount)
{
  rvh->RichView->Clear();
  Graphics::TBitmap*bmp = new Graphics::TBitmap;
  bmp->Assign(Image1->Picture->Bitmap);
  rvh->RichView->AddPictureEx("", bmp, 1, rvvaBaseline);
  rvh->RichView->Add("<<Header>> "+IntToStr(PageNo)+"/"+IntToStr(PageCount),0);
}
//---------------------------------------------------------------------------
void TForm1::MakeFooter(TRVReportHelper*rvh, int PageNo, int PageCount)
{
  rvh->RichView->Clear();
  TRVTableItemInfo*table = new TRVTableItemInfo(1,3,rvh->RichView->RVData);
  table->Cells[0][0]->Clear();
  table->Cells[0][1]->Clear();
  table->Cells[0][2]->Clear();
  table->Rows->Items[0]->VAlign = rvcMiddle;
  Graphics::TBitmap*bmp = new Graphics::TBitmap;
  bmp->Assign(Image1->Picture->Bitmap);
  table->Cells[0][0]->AddNL(IntToStr(PageNo)+"/"+IntToStr(PageCount),0,1);
  table->Cells[0][1]->AddNL("<<Footer>>",0,1);
  table->Cells[0][2]->AddPictureEx("", bmp, 1, rvvaBaseline);
  table->Cells[0][0]->BestWidth=100;
  table->Cells[0][2]->BestWidth=bmp->Width+10;
  table->BestWidth=-100;
  rvh->RichView->AddItem("", table);
}
//---------------------------------------------------------------------------
void GetPageSize(TRVPrint* RVPrint, int&Width, int&Height)
{
  int phoX, phoY, phW, phH, lpy, lpx, LM, TM, RM, BM;
  HDC DC = RV_GetPrinterDC();

  Width  = GetDeviceCaps(DC, HORZRES);
  Height = GetDeviceCaps(DC, VERTRES);

  lpy = GetDeviceCaps(DC, LOGPIXELSY);
  lpx = GetDeviceCaps(DC, LOGPIXELSX);

  phoX = GetDeviceCaps(DC, PHYSICALOFFSETX);
  phoY = GetDeviceCaps(DC, PHYSICALOFFSETY);
  phW  = GetDeviceCaps(DC, PHYSICALWIDTH);
  phH  = GetDeviceCaps(DC, PHYSICALHEIGHT);

  LM = MulDiv(RVPrint->LeftMarginMM,   5*lpx, 127)- phoX;
  TM = MulDiv(RVPrint->TopMarginMM,    5*lpy, 127)- phoY;
  RM = MulDiv(RVPrint->RightMarginMM,  5*lpx, 127)- (phW-(phoX+Width));
  BM = MulDiv(RVPrint->BottomMarginMM, 5*lpy, 127)- (phH-(phoY+Height));

  if (LM<0) LM = 0;
  if (TM<0) TM = 0;
  if (RM<0) RM = 0;
  if (BM<0) BM = 0;

  Width -= LM+RM;
  Height -= TM+BM;

  DeleteDC(DC);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  rvhHeader->RichView->Style = RVStyle1;
  rvhFooter->RichView->Style = RVStyle1;

  rvhHeader->TransparentBackground = True;
  rvhFooter->TransparentBackground = True;

  MakeHeader(rvhHeader,1,1);
  MakeFooter(rvhFooter,1,1);

  int Width, Height;

  GetPageSize(RVPrint1, Width, Height);

  HDC DC = RV_GetPrinterDC();
  TCanvas* Canvas = new TCanvas;
  Canvas->Handle = DC;
  Canvas->Font->PixelsPerInch = GetDeviceCaps(DC, LOGPIXELSY);

  rvhHeader->Init(Canvas, Width);
  rvhHeader->FormatNextPage(Height);
  HeaderHeight = rvhHeader->GetLastPageHeight();
  rvhFooter->Init(Canvas, Width);
  rvhFooter->FormatNextPage(Height);
  FooterHeight = rvhFooter->GetLastPageHeight();

  RVPrint1->TopMarginMM =
    RVPrint1->TopMarginMM+MulDiv(HeaderHeight, 127, 5*GetDeviceCaps(DC, LOGPIXELSY));
  RVPrint1->BottomMarginMM =
    RVPrint1->BottomMarginMM+MulDiv(FooterHeight, 127, 5*GetDeviceCaps(DC, LOGPIXELSY));

  Canvas->Handle = 0;
  DeleteDC(DC);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RVPrint1PagePrepaint(TRVPrint *Sender, int PageNo,
      TCanvas *Canvas, bool Preview, TRect &PageRect, TRect &PrintAreaRect)
{
  MakeHeader(rvhHeader,PageNo,Sender->PagesCount);
  MakeFooter(rvhFooter,PageNo,Sender->PagesCount);
  HDC DC = RV_GetPrinterDC();
  TCanvas* ACanvas = new TCanvas;
  ACanvas->Handle = DC;
  ACanvas->Font->PixelsPerInch = GetDeviceCaps(DC, LOGPIXELSY);
  rvhHeader->Init(ACanvas, PrintAreaRect.Right-PrintAreaRect.Left);
  rvhHeader->FormatNextPage(PrintAreaRect.Bottom-PrintAreaRect.Top);
  rvhFooter->Init(ACanvas, PrintAreaRect.Right-PrintAreaRect.Left);
  rvhFooter->FormatNextPage(PrintAreaRect.Bottom-PrintAreaRect.Top);
  // in the last version (1.8.26.6), you can use DrawPageEx instead
  // of SetWindowOrgEx+DrawPage
  TPoint pt;
  SetWindowOrgEx(Canvas->Handle,
      -PrintAreaRect.Left, -(PrintAreaRect.Top-rvhHeader->GetLastPageHeight()), &pt);
  rvhHeader->DrawPage(1, Canvas, Preview, rvhHeader->GetLastPageHeight());
  SetWindowOrgEx(Canvas->Handle,
      -PrintAreaRect.Left, -PrintAreaRect.Bottom, NULL);
  rvhFooter->DrawPage(1, Canvas, Preview, rvhFooter->GetLastPageHeight());
  SetWindowOrgEx(Canvas->Handle, pt.x, pt.y, NULL);
  ACanvas->Handle = 0;
  DeleteDC(DC);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  RVPrint1->AssignSource(RichViewEdit1);
  RVPrint1->FormatPages(TRVDisplayOptions());
  Form2->ScrollBar1->Min = 1;
  Form2->ScrollBar1->Max = RVPrint1->PagesCount;
  Form2->RVPrintPreview1->RVPrint = RVPrint1;
  Form2->RVPrintPreview1->PageNo = 1;
  Form2->RVPrintPreview1->UpdateView();
  Form2->ScrollBar1->Position = 1;
  Form2->ShowModal();  
}
//---------------------------------------------------------------------------
